/*
 * $Revision: 1.4 $
 */

#include <sys/ioccom.h>

#define ODS2_BLOCK_SIZE 512

struct fid_t
{
    unsigned short fid_w_num;
    unsigned short fid_w_seq;
    unsigned char fid_b_rvn;
    unsigned char fid_b_nmx;
};

#define FID_S_LENGTH 6

#define FILE_NUMBER(fid) (fid.fid_w_num | fid.fid_b_nmx << 16)

#define MFD_FILE_NUMBER 4
#define INDEXF_FILE_NUMBER 1
#define BITMAP_FILE_NUMBER 2

struct rms_attrib_t
{
    unsigned char fat_b_rtype;
    unsigned char fat_b_rattrib;
    unsigned short fat_w_rsize;
    unsigned fat_l_hiblk;
    unsigned fat_l_efblk;
    unsigned short fat_w_ffbyte;
    unsigned char fat_b_bktsize;
    unsigned char fat_b_vfcsize;
    unsigned short fat_w_maxrec;
    unsigned short fat_w_defext;
    unsigned short fat_w_gbc;
    unsigned char fill_1[6];
    unsigned short fill_2;
    unsigned short fat_w_versions;
};

#define RMS_ATTRIB_S_LENGTH 32

#define INVERT(p) \
((* ((unsigned short *) (p))) << 16) | ((* (((unsigned short *) (p))+1)))

struct uic_t
{
    unsigned short int uid;
    unsigned short int gid;
};

#define UIC_S_LENGTH 4

/*
struct protection_t
{
    union
    {
        unsigned short int protection;
        struct
        {
            unsigned system : 4;
            unsigned owner  : 4;
            unsigned group  : 4;
            unsigned world  : 4;
        } four_sets;
    } protection;
};

#define PROTECTION_S_LENGTH 2

#define SYSTEM_PROTECTION protection.four_sets.system
#define OWNER_PROTECTION  protection.four_sets.owner
#define GROUP_PROTECTION  protection.four_sets.group
#define WORLD_PROTECTION  protection.four_sets.world
*/

#define OWNER_PROTECTION(prot) (((prot) & 0x00F0) >> 4)
#define GROUP_PROTECTION(prot) (((prot) & 0x0F00) >> 8)
#define WORLD_PROTECTION(prot) (((prot) & 0xF000) >> 12)

#define ODS2_D 0x04
#define ODS2_X 0x03
#define ODS2_W 0x02
#define ODS2_R 0x01

struct structure_level_t
{
    union
    {
        unsigned short fh2_w_struclev;
        struct
        {
            unsigned char version;
            unsigned char level;
        } s_structlev;
    } structlev;
};

#define fh2_b_struclev_version structlev.s_structlev.version
#define fh2_b_struclev_level   structlev.s_structlev.level

struct class_protection_t
{
    unsigned char cls_b_secur_lev;
    unsigned char cls_b_integ_lev;
    short fill_1;
    unsigned cls_q_secur_cat[2];
    unsigned cls_q_integ_cat[2];
};

struct vms_time_t
{
    unsigned low;
    unsigned high;
};

struct fi2_t
{
    unsigned char fi2_t_filename[20];
    unsigned short int fi2_w_revision;
    struct vms_time_t fi2_q_credate;
    struct vms_time_t fi2_q_revdate;
    struct vms_time_t fi2_q_expdate;
    struct vms_time_t fi2_q_bakdate;
    unsigned char fi2_t_filenamext[66];
};

struct fm2_0_t
{
    unsigned fm2_2_word0  : 14;
    unsigned fm2_v_format :  2;
};

struct fm2_1_t
{
    unsigned fm2_b_count1  : 8;
    unsigned fm2_v_highlbn : 6;
    unsigned fm2_v_format  : 2;
    unsigned fm2_w_lowlbn  : 16;
};

#define COUNT_1(fm2_1) ((fm2_1).fm2_b_count1)
#define LBN_1(fm2_1) ((fm2_1).fm2_v_highlbn << 16 | (fm2_1).fm2_w_lowlbn)

struct fm2_2_t
{
    unsigned fm2_v_count2 : 14;
    unsigned fm2_v_format :  2;
    unsigned fm2_l_lbn2_1 : 16;
    unsigned fm2_l_lbn2_2 : 16;
};

#define MAPPING_TYPE(fm) (((struct fm2_0_t *) (fm))->fm2_v_format)
#define FM2_C_PLACEMENT 0
#define FM2_S_PLACEMENT 2

#define FM2_C_FORMAT1   1
#define FM2_S_FORMAT1   4

#define FM2_C_FORMAT2   2
#define FM2_S_FORMAT2   6

#define FM2_C_FORMAT3   3
#define FM2_S_FORMAT3   8

#define COUNT_2(fm2_2) ((fm2_2).fm2_v_count2)
#define LBN_2(fm2_2) ((fm2_2).fm2_l_lbn2_2 << 16 | (fm2_2).fm2_l_lbn2_1)

struct fm2_3_t
{
    unsigned fm2_v_count2   : 14;
    unsigned fm2_v_format   :  2;
    unsigned fm2_w_lowcount : 16;
    unsigned fm2_l_lbn3     : 32;
};

#define COUNT_3(fm2_3) ((fm2_3).fm2_v_count2 << 16 | (fm2_3).fm2_w_lowcount)
#define LBN_3(fm2_3) ((fm2_3).fm2_l_lbn3)

struct file_header_t
{
    unsigned char fh2_b_idoffset;
    unsigned char fh2_b_mpoffset;
    unsigned char fh2_b_acoffset;
    unsigned char fh2_b_rsoffset;
    unsigned short fh2_w_seg_num;
    struct structure_level_t fh2_w_struclev;
    struct fid_t fh2_w_fid;
    struct fid_t fh2_w_ext_fid;
    struct rms_attrib_t fh2_w_recattr;
    unsigned fh2_l_filechar;
#define FCH_M_CONTIG    0x00000080
#define FCH_M_DIRECTORY 0x00002000
#define FCH_M_MARKDEL   0x00008000
    short fill_1;
    unsigned char fh2_b_map_inuse;
    unsigned char fh2_b_acc_mode;
    struct uic_t fh2_l_fileowner;
/*    struct protection_t fh2_w_fileprot; */
    unsigned short int fh2_w_fileprot;
    struct fid_t fh2_w_backlink;
    unsigned char fh2_b_journal;
    unsigned char fh2_b_ru_active;
    short fill_2;
    unsigned fh2_l_highwater;
    char fill_3[8];
    struct class_protection_t fh2_r_class_prot;
    char fill_4[512-88-2];
    unsigned short fh2_w_checksum;
};

#define FH2_S_HIGHWATER 76
#define FH2_S_HIGHWATER_D2 (FH2_S_HIGHWATER/2)
#define FH2_S_LENGTH 512
#define FH2_C_CHECKSUM 510
#define FI2_AREA(fhp) ((struct fi2_t *) (((unsigned short *) (fhp)) + \
					 ((fhp)->fh2_b_idoffset)))
#define FM2_AREA(fhp) ((unsigned char *) (((unsigned short *) (fhp)) + \
					 ((fhp)->fh2_b_mpoffset)))

/*
 * XXX: ACE not yet implemented!
 */

/*
 * XXX: symlink directory entries not implemented!
 */

struct dir_entry_t
{
    unsigned short int dir_w_version;
    struct fid_t dir_w_fid;
};

#define DIR_S_ENTRY_FID (2+sizeof(struct fid_t))

struct dir_record_t
{
    short int dir_w_size;
    short int dir_w_verlimit;
    unsigned char dir_b_flags;
    unsigned char dir_b_namecount;
    unsigned char dir_t_name[1];
};

#define DIR_S_DIR_RECORD_OVERHEAD (2+1+1)

struct home_block_t
{
    unsigned hm2_l_homelbn;
    unsigned hm2_l_alhomelbn;
    unsigned hm2_l_altidxlbn;
    struct structure_level_t hm2_w_struclev;
    unsigned short hm2_w_cluster;
    unsigned short hm2_w_homevbn;
    unsigned short hm2_w_alhomevbn;
    unsigned short hm2_w_altidxvbn;
    unsigned short hm2_w_ibmapvbn;
    unsigned hm2_l_ibmaplbn;
    unsigned hm2_l_maxfiles;
    unsigned short hm2_w_ibmapsize;
    unsigned short hm2_w_resfiles;
    unsigned short hm2_w_devtype;
    unsigned short hm2_w_rvn;
    unsigned short hm2_w_setcount;
    unsigned short hm2_w_volchar;
    struct uic_t hm2_l_volowner;
    unsigned fill_1;
/*
    struct protection_t hm2_w_protect;
    struct protection_t hm2_w_fileprot;
*/
    unsigned short int hm2_w_protect;
    unsigned short int hm2_w_fileprot;
    unsigned short fill_2;
    unsigned short hm2_w_checksum1;
    struct vms_time_t hm2_q_credate;
    unsigned char hm2_b_window;
    unsigned char hm2_b_lru_lim;
    unsigned short hm2_w_extend;
    struct vms_time_t hm2_q_retainmin;
    struct vms_time_t hm2_q_retainmax;
    struct vms_time_t hm2_q_revdate;
    struct class_protection_t hm2_r_min_class;
    struct class_protection_t hm2_r_max_class;
    unsigned char fill_3[320];
    unsigned hm2_l_serialnum;
    unsigned char hm2_t_strucname[12];
    unsigned char hm2_t_volname[12];
    unsigned char hm2_t_ownername[12];
    unsigned char hm2_t_format[12];
    unsigned short fill_4;
    unsigned short hm2_w_checksum2;
};

#define HM2_C_CHECKSUM1  58
#define HM2_C_CHECKSUM2 510
#define DECFILE11B "DECFILE11B  "

struct scb_t
{
    struct structure_level_t scb_w_struclev;
    unsigned short int scb_w_cluster;
    unsigned int scb_l_volsize;
    unsigned int scb_l_blksize;
    unsigned int scb_l_sectors;
    unsigned int scb_l_tracks;
    unsigned int scb_l_cylinder;
    unsigned int scb_l_status;
    unsigned int scb_l_status2;
    unsigned short int scb_w_writecnt;
    unsigned char scb_t_volockname[12];
    struct vms_time_t scb_q_mounttime;
    unsigned short int scb_w_backrev;
    struct vms_time_t scb_q_genernum;
    unsigned char fill_1[446];
    unsigned short int scb_w_checksum;
};

/*
 * The args to the file system mount are a subset of the MOUNT args in DCL.
 * The minimum currently implemented is "full home block search".
 */

struct ods2_args {
    char *fspec;                   /* block special device to mount */
    struct export_args export;     /* network export information */
    unsigned int flags;            /* see below */
};

#define ODS2MNT_FULL_HOMEBLOCK_SEARCH 0x00000001
#define ODS2MNT_LOWERCASE             0x00000002
#define ODS2MNT_NODIREXT              0x00000004
#define ODS2MNT_FAST_NODIREXT         0x00000008

struct mapping_t
{
    unsigned lbn;
    unsigned count;
};

/*
 * Command to "ioctl" on the file handle
 *     IODS2IOCGRMS_ATTRIB - returns the "struct rms_attrib_t" for the file
 */

#define ODS2IOCGRMS_ATTRIB _IOWR('O', 0, struct rms_attrib_t)

#if defined(KERNEL) || defined(_KERNEL)

struct ods2_geometry
{
    unsigned int sector_size;
    unsigned int block_shift;
    unsigned int block_mask;
};

struct ods2_mount {
    struct mount *ods2_vfs;       /* vfs structure */
    dev_t ods2_dev;               /* device mounted */
    struct vnode *ods2_devvp;     /* vnode of mounted block device */
    struct netexport export;

    struct ods2_geometry geometry;

    unsigned int total_blocks;      /* Total blocks in file system */
    unsigned int indexf_vbn;        /* VBN of INDEXF.SYS.  On Unix, this is */
                                    /* referred to as LBN.  The VMS LBN is  */
                                    /* referred to as physical block!       */
    unsigned int flags;

    struct vnode *indexf;
    struct vnode *mfd;

    unsigned int maxfiles;
    int fid_directory_fid;

    struct vnode *fid_directory;
};

#define HEADER_VBN(imp, ino) ((imp).indexf_vbn + (ino) - 1)

/*
 * A cache of vnode references
 *    dev_t i_dev - required for hashing
 *    ino_t i_num - required for hashing.  Just the FILE_NUMBER
 */
struct ods2_node {
    struct lock           i_lock;          /* Inode lock. >Keep this first< */
    LIST_ENTRY(ods2_node) ods2_hash;       /* Hash list */
    struct ods2_node	  *i_next;
    struct ods2_node	  **i_prev;
    struct mount          *mount;          /* Pointer to vfs */
    struct vnode          *i_vnode;        /* Associated vnode to this inode */
    struct vnode          *i_devvp;        /* vnode of device where inode is */
    dev_t                 i_dev;           /* Device on which inode resides */
    ino_t                 i_num;           /* inode number */
    u_quad_t              i_size;          /* File size, in bytes */

    struct file_header_t  *file_header;    /* Main file header for file */
};

#define	MOUNTTOODS2MOUNT(mp) ((struct ods2_mount *)((mp)->mnt_data))
#define	VTOODS2(vp) ((struct ods2_node *)(vp)->v_data)
#define	ODS2TOV(xp) ((xp)->i_vnode)

#ifdef MALLOC_DECLARE
MALLOC_DECLARE(M_ODS2FSMNT);
MALLOC_DECLARE(M_ODS2FSNODE);
MALLOC_DECLARE(M_ODS2FSFH);
#endif

void    ods2_ihashrem __P((struct ods2_node *ip));
struct vnode *ods2_ihashget __P((dev_t dev, ino_t inum));
void    ods2_ihashins __P((struct ods2_node *ip));
int     ods2_init __P((struct vfsconf *vfsp));
int     ods2_bmap __P((struct vop_bmap_args *ap));
int     ods2_lookup __P((struct vop_cachedlookup_args *ap));
int     ods2_vget __P((struct mount *mp, ino_t ino, struct vnode **vpp));
int     ods2_read_file_header __P((struct mount *mp,
                                   ino_t ino,
                                   struct file_header_t **fh2));

#if __FreeBSD__==3
int	ods2_fhtovp __P((struct mount *mp, struct fid *fidp,
                         struct sockaddr *nam, struct vnode **vpp,
                         int *exflagsp, struct ucred **credanonp));
#else
int	ods2_fhtovp __P((struct mount *mp, struct fid *fidp,
			struct vnode **vpp));
#endif

int	ods2_bread __P((struct vnode *vp, struct ods2_geometry *geometry,
                        daddr_t lbn, struct ucred *cred,
                        unsigned char *block));
int	ods2_mount __P((struct mount *mp, char *path, caddr_t data,
                        struct nameidata *ndp, struct proc *p));
int	ods2_quotactl __P((struct mount *mp, int cmd, uid_t uid,
                           caddr_t arg, struct proc *p));
int	ods2_root __P((struct mount *mp, struct vnode **vpp));
int	ods2_start __P((struct mount *mp, int flags, struct proc *p));
int	ods2_statfs __P((struct mount *mp, struct statfs *sbp,
                         struct proc *p));
int	ods2_sync __P((struct mount *mp, int waitfor,
                       struct ucred *cred, struct proc *p));
int	ods2_unmount __P((struct mount *mp, int mntflags,
                          struct proc *p));
int	ods2_vptofh __P((struct vnode *vp, struct fid *fhp));

int	ods2_checkexp __P((struct mount *mp,
                           struct sockaddr *nam,
                           int *exflagsp,
                           struct ucred **credanonp));

#endif /* KERNEL */
